package thesis.main;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

public class Entropy {

	public static final String J_CLA_1 = "jaguar car";
	public static final String J_CLA_2 = "animal";
	public static final String J_CLA_3 = "sports";
	public static final String J_CLA_4 = "travel";
	public static final String J_CLA_5 = "business";
	public static final String J_CLA_6 = "shopping";
	public static final String J_CLA_7 = "music";
	public static final String J_CLA_8 = "it";
	public static final String J_CLA_9 = "education";
	public static final String J_CLA_10 = "entertainment";
	public static final String J_CLA_11 = "society";
	public static final String J_CLA_12 = "military";
	public static final String J_CLA_13 = "miscellaneous";
	
	public static final String B_CLA_1 = "news";
	public static final String B_CLA_2 = "business";
	public static final String B_CLA_3 = "new york city";
	public static final String B_CLA_4 = "art";
	public static final String B_CLA_5 = "animal";
	public static final String B_CLA_6 = "travel";
	public static final String B_CLA_7 = "food";
	public static final String B_CLA_8 = "entertainment";
	public static final String B_CLA_9 = "sports";
	public static final String B_CLA_10 = "education";
	public static final String B_CLA_11 = "media";
	public static final String B_CLA_12 = "shopping";
	public static final String B_CLA_13 = "personal";
	public static final String B_CLA_14 = "miscellaneous";
	
	public static HashMap<String, String> global_map = new HashMap<String, String>();
	
	/**
	 * @param args
	 */
	
	public static void initBigApple()
	{
		// Initial global_map BIG APPLE
		global_map.put(B_CLA_1, "0");
		global_map.put(B_CLA_2, "0");
		global_map.put(B_CLA_3, "0");
		global_map.put(B_CLA_4, "0");
		global_map.put(B_CLA_5, "0");
		global_map.put(B_CLA_6, "0");
		global_map.put(B_CLA_7, "0");
		global_map.put(B_CLA_8, "0");
		global_map.put(B_CLA_9, "0");
		global_map.put(B_CLA_10, "0");
		global_map.put(B_CLA_11, "0");
		global_map.put(B_CLA_12, "0");
		global_map.put(B_CLA_13, "0");
		global_map.put(B_CLA_14, "0");
	}
	
	public static void initJaguar()
	{
		// Initial global_map JAGUAR
		global_map.put(J_CLA_1, "0");
		global_map.put(J_CLA_2, "0");
		global_map.put(J_CLA_3, "0");
		global_map.put(J_CLA_4, "0");
		global_map.put(J_CLA_5, "0");
		global_map.put(J_CLA_6, "0");
		global_map.put(J_CLA_7, "0");
		global_map.put(J_CLA_8, "0");
		global_map.put(J_CLA_9, "0");
		global_map.put(J_CLA_10, "0");
		global_map.put(J_CLA_11, "0");
		global_map.put(J_CLA_12, "0");
		global_map.put(J_CLA_13, "0");
	}
	
	public static void main(String[] args) {

		// Clusters
		String clu1 = "0, 1, 6, 11, 14, 15, 16, 22, 23, 24, 25, 27, 29, 32, 33, 37, 39, 44, 48, 50, 51, 53, 55, 62, 64, 66, 72, 73, 74, 79, 86, 88, 89, 93, 96, 97, 98, 100, 104, 105, 108, 109, 110, 111, 113, 115, 116, 117, 118, 120, 122, 124, 134, 135, 137, 138, 142, 145, 147, 148, 151, 156, 157, 158, 160, 161, 164, 167, 170, 171, 172, 174, 175, 176, 177, 179, 180, 186, 189, 193";
		String clu2 = "20, 35, 46, 59, 68, 81, 87, 127, 143, 146, 154, 162, 163, 169, 184";
		String clu3 = "3";
		String clu4 = "34, 65, 69, 83, 106, 133, 140, 141, 144, 152, 165";
		String clu5 = "4, 41, 101, 132, 190";
		String clu6 = "8, 18, 28, 31, 42, 54, 60, 76, 94, 103, 112, 155, 168";
		String clu7 = "121, 125, 130, 131";
		String clu8 = "10, 12, 19, 38, 40, 58, 85, 91, 150, 182, 183, 188";
		String clu9 = "84, 107, 119, 153";
		String clu10 = "2, 13, 56, 90, 123, 128";
		String clu11 = "21, 36, 43, 45, 49, 78, 92, 114, 126, 136, 173, 181, 191, 192";
		String clu12 = "5, 7, 9, 17, 26, 30, 47, 52, 57, 61, 63, 67, 70, 71, 75, 77, 80, 82, 95, 99, 102, 129, 139, 149, 159, 166, 178, 185, 187";
		
		// JAGUAR CLASSES
		String j_cla1 = "0,1,109,131,173,57,110,112,113,114,118,121,122,124,125,126,130,132,134,135,136,137,145,149,150,153,155,156,159,160,161,166,170,171,172,177,178,179,181,182,183,185,186,188,189,190,191,192,4,6,8,9,10,11,12,14,16,17,18,19,21,22,23,25,26,27,30,31,32,33,36,38,40,43,44,45,47,48,49,50,51,52,53,55,58,60,61,63,64,66,67,69,70,71,72,74,75,76,77,78,80,82,85,86,89,91,92,93,95,96,99,102,103,108";
		String j_cla2 = "120,141,151,162,184,46,68,117,133,138,140,143,144,146,152,154,157,163,164,175,5,15,34,37,42,59,65,81,83,84,87,105";
		String j_cla3 = "35,167,168,180,101";
		String j_cla4 = "165,169,187,104,106";
		String j_cla5 = "90,123,158,56,107,174,7,62";
		String j_cla6 = "100,127,129,139,20";
		String j_cla7 = "176,193,54,73,97";
		String j_cla8 = "2,13,115,116,119,3,24,79,142,148,28,29";
		String j_cla9 = "88";
		String j_cla10 = "39,94,147";
		String j_cla11 = "41";
		String j_cla12 = "128";
		String j_cla13 = "111,98";
		
		// BIG_APPLE CLASSES
//		String b_cla1 = "4,12,192,16,18,23,26,27,31,38,41,44,46,48,51,52,58,59,61,62,64, 66,68,69,72,79,81,83,84,85,86,91,92,95,96,99,108,117,43";
//		String b_cla2 = "57,50,7,5,11,21,77,184,156,14,19,145,37,144,8,143,3,120,173,194,56";
//		String b_cla3 = "0,109,115,116,154,181,9,114,126,127,128,148,149,167,101 ";
//		String b_cla4 = "1,121,130,153,164,176,195,17,29,35,90";
//		String b_cla5 = "174,178,30,53,22 ";
//		String b_cla6 = "13,24,112,119,123,39,185,2,33,133,158,25,55";
//		String b_cla7 = "87,113,122,137,147,150,166,171,193,60,63,73,78,103,45,110,70,163,34,140,100 ";
//		String b_cla8 = "124,125,131,132,134,155,161,172,49,74,82,141,152,67,98,177,80, 169,189";
//		String b_cla9 = "136,139,151,157,160,135,142,170,186,191,13,54,76,102,15";
//		String b_cla10 = "159,182,104";
//		String b_cla11 = "162,179,180,187,138,93,106,129,94";
//		String b_cla12 = "168,175,188,190,118,6,10,32,40,65,75,165,183,146";
//		String b_cla13 = "20,36,71,111";
//		String b_cla14 = "42,47,88,97,107,28,89,105";
		
		// Initialize jaguar class map
		HashMap<String, String> cla = new HashMap<String, String>();
		addToMap(J_CLA_1, j_cla1, cla);
		addToMap(J_CLA_2, j_cla2, cla);
		addToMap(J_CLA_3, j_cla3, cla);
		addToMap(J_CLA_4, j_cla4, cla);
		addToMap(J_CLA_5, j_cla5, cla);
		addToMap(J_CLA_6, j_cla6, cla);
		addToMap(J_CLA_7, j_cla7, cla);
		addToMap(J_CLA_8, j_cla8, cla);
		addToMap(J_CLA_9, j_cla9, cla);
		addToMap(J_CLA_10, j_cla10, cla);
		addToMap(J_CLA_11, j_cla11, cla);
		addToMap(J_CLA_12, j_cla12, cla);
		addToMap(J_CLA_13, j_cla13, cla);
	
		// Initialize big apple class map
//		HashMap<String, String> cla_apple = new HashMap<String, String>();
//		addToMap(B_CLA_1, b_cla1, cla_apple);
//		addToMap(B_CLA_2, b_cla2, cla_apple);
//		addToMap(B_CLA_3, b_cla3, cla_apple);
//		addToMap(B_CLA_4, b_cla4, cla_apple);
//		addToMap(B_CLA_5, b_cla5, cla_apple);
//		addToMap(B_CLA_6, b_cla6, cla_apple);
//		addToMap(B_CLA_7, b_cla7, cla_apple);
//		addToMap(B_CLA_8, b_cla8, cla_apple);
//		addToMap(B_CLA_9, b_cla9, cla_apple);
//		addToMap(B_CLA_10, b_cla10, cla_apple);
//		addToMap(B_CLA_11, b_cla11, cla_apple);
//		addToMap(B_CLA_12, b_cla12, cla_apple);
//		addToMap(B_CLA_13, b_cla13, cla_apple);
//		addToMap(B_CLA_14, b_cla14, cla_apple);
		
		// Print jaguar
		printSingleClusterCount(countForSingleCluster(clu1, cla), "CLU_1");
		printSingleClusterCount(countForSingleCluster(clu2, cla), "CLU_2");
		printSingleClusterCount(countForSingleCluster(clu3, cla), "CLU_3");
		printSingleClusterCount(countForSingleCluster(clu4, cla), "CLU_4");
		printSingleClusterCount(countForSingleCluster(clu5, cla), "CLU_5");
		printSingleClusterCount(countForSingleCluster(clu6, cla), "CLU_6");
		printSingleClusterCount(countForSingleCluster(clu7, cla), "CLU_7");
		printSingleClusterCount(countForSingleCluster(clu8, cla), "CLU_8");
		printSingleClusterCount(countForSingleCluster(clu9, cla), "CLU_9");
		printSingleClusterCount(countForSingleCluster(clu10, cla), "CLU_10");
		printSingleClusterCount(countForSingleCluster(clu11, cla), "CLU_11");
		printSingleClusterCount(countForSingleCluster(clu12, cla), "CLU_12");
		
		// print big apple
//		printSingleClusterCount(countForSingleCluster(clu1, cla_apple), "CLU_1");
//		printSingleClusterCount(countForSingleCluster(clu2, cla_apple), "CLU_2");
//		printSingleClusterCount(countForSingleCluster(clu3, cla_apple), "CLU_3");
//		printSingleClusterCount(countForSingleCluster(clu4, cla_apple), "CLU_4");
//		printSingleClusterCount(countForSingleCluster(clu5, cla_apple), "CLU_5");
//		printSingleClusterCount(countForSingleCluster(clu6, cla_apple), "CLU_6");
//		printSingleClusterCount(countForSingleCluster(clu7, cla_apple), "CLU_7");
//		printSingleClusterCount(countForSingleCluster(clu8, cla_apple), "CLU_8");
//		printSingleClusterCount(countForSingleCluster(clu9, cla_apple), "CLU_9");
//		printSingleClusterCount(countForSingleCluster(clu10, cla_apple), "CLU_10");
//		printSingleClusterCount(countForSingleCluster(clu11, cla_apple), "CLU_11");
//		printSingleClusterCount(countForSingleCluster(clu12, cla_apple), "CLU_12");
	}
	
	public static void addToMap(String name, String classContent, HashMap<String, String> cla)
	{
		ArrayList<String> list = stringToArray(classContent);
		for (int i = 0; i < list.size(); i++)
			cla.put(list.get(i), name);
	}
	
	public static void printSingleClusterCount(HashMap<String, ArrayList<String>> map, String clu_name)
	{
		//initBigApple();
		initJaguar();
		//System.out.println(global_map.size());
		Set<String> x = map.keySet();
		Iterator<String> it = x.iterator();
		System.out.print(clu_name);
		System.out.print("\t");
		
		while (it.hasNext())
		{
			String cla_name = it.next();
			ArrayList<String> list = map.get(cla_name);
			if (global_map.containsKey(cla_name))
			{
				global_map.put(cla_name, String.valueOf(list.size()));
			}
		}
		
		Set<String> y = global_map.keySet();
		Iterator<String> it1 = y.iterator();
		while (it1.hasNext())
		{
			String cla_name1 = it1.next();
			String value = global_map.get(cla_name1);
			System.out.print(value);
			System.out.print("\t");
		}
		System.out.println();
	}
	
	public static HashMap<String, ArrayList<String>> countForSingleCluster(String clusterContent, HashMap<String, String> cla)
	{
		HashMap<String, ArrayList<String>> result = new HashMap<String, ArrayList<String>>();
		ArrayList<String> cluster = stringToArray(clusterContent);
		ArrayList<String> list = null;
		String cla_name = null, member = null;
		
		for (int i = 0; i < cluster.size(); i++)
		{
			member = cluster.get(i);
			if (cla.containsKey(member))
				cla_name = cla.get(member);
			else
			{
				System.err.println("[ERROR] The document " + member + " doesn't belong to any class!");
			}
			
			if (result.containsKey(cla_name))
				list = result.get(cla_name);
			else
				list = new ArrayList<String>();
			
			list.add(member);
			result.put(cla_name, list);
		}
		
		return result;
	}
		
	public static ArrayList<String> stringToArray(String data)
	{
		data = data.replaceAll(" ", "");
		String[] members = data.split(",");
		ArrayList<String> result = new ArrayList<String>();
		for (int i = 0; i < members.length; i++)
			result.add(members[i]);

		return result;
	}

}
