package thesis.main;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.HashMap;

import org.htmlcleaner.XPatherException;

import thesis.crawler.HtmlParser;

public class Test_ExtractOutLinksFromPage {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws XPatherException 
	 */
	public static void main(String[] args) throws IOException, XPatherException {
		// TODO give the value
		//=======================
		String dir = "D:\\12_Master_thesis\\04_Experiment\\2010_5_28_food_200_100";
		String htmlDir = dir + "\\html";
		String fileName = htmlDir+"\\"+"161.htm";
		String url = "http://www.delta.com/traveling_checkin/inflight_services/first_class/dining.jsp";
		String outlinkDir = dir + "\\outlink";
		int index = 161;
		//=======================
		
		
		File html = new File(fileName);
	    FileInputStream fis = null;
	    BufferedInputStream bis = null;
	    DataInputStream dis = null;

	    fis = new FileInputStream(html);
	    // Here BufferedInputStream is added for fast reading.
	    bis = new BufferedInputStream(fis);
	    dis = new DataInputStream(bis);

	    StringBuilder sb = new StringBuilder();
	    // dis.available() returns 0 if the file does not have more lines.
	    while (dis.available() != 0) {
	    	// this statement reads the line from the file and print it to
	    	// the console.
	    	//System.out.println(dis.readLine());
	    	sb.append(dis.readLine());
	    }
	    // dispose all the resources after using them.
	    fis.close();
	    bis.close();
	    dis.close();
	    
	    HashMap<String, Integer> map = HtmlParser.getInstance().getOutlinkDomains(url, sb.toString());
		int outdegree = Test_DownloadSearchResults.writeOutLinkFile(map, outlinkDir, null, index);
		//System.out.println("[INFO] " + index + " " + url);
		System.out.println("    Create out-links file...[OK], outdegree = " + outdegree);
	}

}
