package thesis.vector.combination;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

public class PageRankSerializer {
	
	public static void serialize(ArrayList<String> inputArray, String prFile) throws IOException
	{
		FileOutputStream file = new FileOutputStream(prFile);
		BufferedOutputStream buffer = new BufferedOutputStream(file);
		ObjectOutputStream output = new ObjectOutputStream(buffer);
		
		output.writeObject(inputArray);
		output.close();
	}
	
	@SuppressWarnings("unchecked")
	public static ArrayList<String> deserialize(String prFile) throws IOException, ClassNotFoundException
	{
		FileInputStream file = new FileInputStream(prFile);
		BufferedInputStream buffer = new BufferedInputStream( file );
		ObjectInputStream input = new ObjectInputStream ( buffer );
		
		ArrayList<String> result = (ArrayList<String>) input.readObject();
		return result;
	}

}
